<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">


<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    
    <title>8.11. pprint — Data pretty printer &mdash; Python 3.5.1 documentation</title>
    
    <link rel="stylesheet" href="../_static/pydoctheme.css" type="text/css" />
    <link rel="stylesheet" href="../_static/pygments.css" type="text/css" />
    
    <script type="text/javascript">
      var DOCUMENTATION_OPTIONS = {
        URL_ROOT:    '../',
        VERSION:     '3.5.1',
        COLLAPSE_INDEX: false,
        FILE_SUFFIX: '.html',
        HAS_SOURCE:  true
      };
    </script>
    <script type="text/javascript" src="../_static/jquery.js"></script>
    <script type="text/javascript" src="../_static/underscore.js"></script>
    <script type="text/javascript" src="../_static/doctools.js"></script>
    <script type="text/javascript" src="../_static/sidebar.js"></script>
    <link rel="search" type="application/opensearchdescription+xml"
          title="Search within Python 3.5.1 documentation"
          href="../_static/opensearch.xml"/>
    <link rel="author" title="About these documents" href="../about.html" />
    <link rel="copyright" title="Copyright" href="../copyright.html" />
    <link rel="top" title="Python 3.5.1 documentation" href="../contents.html" />
    <link rel="up" title="8. Data Types" href="datatypes.html" />
    <link rel="next" title="8.12. reprlib — Alternate repr() implementation" href="reprlib.html" />
    <link rel="prev" title="8.10. copy — Shallow and deep copy operations" href="copy.html" />
    <link rel="shortcut icon" type="image/png" href="../_static/py.png" />
    <script type="text/javascript" src="../_static/copybutton.js"></script>
    <script type="text/javascript" src="../_static/version_switch.js"></script>
    
 

  </head>
  <body role="document">  
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="right" >
          <a href="reprlib.html" title="8.12. reprlib — Alternate repr() implementation"
             accesskey="N">next</a> |</li>
        <li class="right" >
          <a href="copy.html" title="8.10. copy — Shallow and deep copy operations"
             accesskey="P">previous</a> |</li>
        <li><img src="../_static/py.png" alt=""
                 style="vertical-align: middle; margin-top: -1px"/></li>
        <li><a href="https://www.python.org/">Python</a> &raquo;</li>
        <li>
          <span class="version_switcher_placeholder">3.5.1</span>
          <a href="../index.html">Documentation</a> &raquo;
        </li>

          <li class="nav-item nav-item-1"><a href="index.html" >The Python Standard Library</a> &raquo;</li>
          <li class="nav-item nav-item-2"><a href="datatypes.html" accesskey="U">8. Data Types</a> &raquo;</li> 
      </ul>
    </div>    

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="module-pprint">
<span id="pprint-data-pretty-printer"></span><h1>8.11. <a class="reference internal" href="#module-pprint" title="pprint: Data pretty printer."><code class="xref py py-mod docutils literal"><span class="pre">pprint</span></code></a> &#8212; Data pretty printer<a class="headerlink" href="#module-pprint" title="Permalink to this headline">¶</a></h1>
<p><strong>Source code:</strong> <a class="reference external" href="https://hg.python.org/cpython/file/3.5/Lib/pprint.py">Lib/pprint.py</a></p>
<hr class="docutils" />
<p>The <a class="reference internal" href="#module-pprint" title="pprint: Data pretty printer."><code class="xref py py-mod docutils literal"><span class="pre">pprint</span></code></a> module provides a capability to &#8220;pretty-print&#8221; arbitrary
Python data structures in a form which can be used as input to the interpreter.
If the formatted structures include objects which are not fundamental Python
types, the representation may not be loadable.  This may be the case if objects
such as files, sockets or classes are included, as well as many other
objects which are not representable as Python literals.</p>
<p>The formatted representation keeps objects on a single line if it can, and
breaks them onto multiple lines if they don&#8217;t fit within the allowed width.
Construct <a class="reference internal" href="#pprint.PrettyPrinter" title="pprint.PrettyPrinter"><code class="xref py py-class docutils literal"><span class="pre">PrettyPrinter</span></code></a> objects explicitly if you need to adjust the
width constraint.</p>
<p>Dictionaries are sorted by key before the display is computed.</p>
<p>The <a class="reference internal" href="#module-pprint" title="pprint: Data pretty printer."><code class="xref py py-mod docutils literal"><span class="pre">pprint</span></code></a> module defines one class:</p>
<dl class="class">
<dt id="pprint.PrettyPrinter">
<em class="property">class </em><code class="descclassname">pprint.</code><code class="descname">PrettyPrinter</code><span class="sig-paren">(</span><em>indent=1</em>, <em>width=80</em>, <em>depth=None</em>, <em>stream=None</em>, <em>*</em>, <em>compact=False</em><span class="sig-paren">)</span><a class="headerlink" href="#pprint.PrettyPrinter" title="Permalink to this definition">¶</a></dt>
<dd><p>Construct a <a class="reference internal" href="#pprint.PrettyPrinter" title="pprint.PrettyPrinter"><code class="xref py py-class docutils literal"><span class="pre">PrettyPrinter</span></code></a> instance.  This constructor understands
several keyword parameters.  An output stream may be set using the <em>stream</em>
keyword; the only method used on the stream object is the file protocol&#8217;s
<code class="xref py py-meth docutils literal"><span class="pre">write()</span></code> method.  If not specified, the <a class="reference internal" href="#pprint.PrettyPrinter" title="pprint.PrettyPrinter"><code class="xref py py-class docutils literal"><span class="pre">PrettyPrinter</span></code></a> adopts
<code class="docutils literal"><span class="pre">sys.stdout</span></code>.  The
amount of indentation added for each recursive level is specified by <em>indent</em>;
the default is one.  Other values can cause output to look a little odd, but can
make nesting easier to spot.  The number of levels which may be printed is
controlled by <em>depth</em>; if the data structure being printed is too deep, the next
contained level is replaced by <code class="docutils literal"><span class="pre">...</span></code>.  By default, there is no constraint on
the depth of the objects being formatted.  The desired output width is
constrained using the <em>width</em> parameter; the default is 80 characters.  If a
structure cannot be formatted within the constrained width, a best effort will
be made.  If <em>compact</em> is false (the default) each item of a long sequence
will be formatted on a separate line.  If <em>compact</em> is true, as many items
as will fit within the <em>width</em> will be formatted on each output line.</p>
<div class="versionchanged">
<p><span class="versionmodified">Changed in version 3.4: </span>Added the <em>compact</em> parameter.</p>
<div class="highlight-python3"><div class="highlight"><pre><span class="gp">&gt;&gt;&gt; </span><span class="kn">import</span> <span class="nn">pprint</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">stuff</span> <span class="o">=</span> <span class="p">[</span><span class="s">&#39;spam&#39;</span><span class="p">,</span> <span class="s">&#39;eggs&#39;</span><span class="p">,</span> <span class="s">&#39;lumberjack&#39;</span><span class="p">,</span> <span class="s">&#39;knights&#39;</span><span class="p">,</span> <span class="s">&#39;ni&#39;</span><span class="p">]</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">stuff</span><span class="o">.</span><span class="n">insert</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span> <span class="n">stuff</span><span class="p">[:])</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">pp</span> <span class="o">=</span> <span class="n">pprint</span><span class="o">.</span><span class="n">PrettyPrinter</span><span class="p">(</span><span class="n">indent</span><span class="o">=</span><span class="mi">4</span><span class="p">)</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">pp</span><span class="o">.</span><span class="n">pprint</span><span class="p">(</span><span class="n">stuff</span><span class="p">)</span>
<span class="go">[   [&#39;spam&#39;, &#39;eggs&#39;, &#39;lumberjack&#39;, &#39;knights&#39;, &#39;ni&#39;],</span>
<span class="go">    &#39;spam&#39;,</span>
<span class="go">    &#39;eggs&#39;,</span>
<span class="go">    &#39;lumberjack&#39;,</span>
<span class="go">    &#39;knights&#39;,</span>
<span class="go">    &#39;ni&#39;]</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">pp</span> <span class="o">=</span> <span class="n">pprint</span><span class="o">.</span><span class="n">PrettyPrinter</span><span class="p">(</span><span class="n">width</span><span class="o">=</span><span class="mi">41</span><span class="p">,</span> <span class="n">compact</span><span class="o">=</span><span class="k">True</span><span class="p">)</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">pp</span><span class="o">.</span><span class="n">pprint</span><span class="p">(</span><span class="n">stuff</span><span class="p">)</span>
<span class="go">[[&#39;spam&#39;, &#39;eggs&#39;, &#39;lumberjack&#39;,</span>
<span class="go">  &#39;knights&#39;, &#39;ni&#39;],</span>
<span class="go"> &#39;spam&#39;, &#39;eggs&#39;, &#39;lumberjack&#39;, &#39;knights&#39;,</span>
<span class="go"> &#39;ni&#39;]</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">tup</span> <span class="o">=</span> <span class="p">(</span><span class="s">&#39;spam&#39;</span><span class="p">,</span> <span class="p">(</span><span class="s">&#39;eggs&#39;</span><span class="p">,</span> <span class="p">(</span><span class="s">&#39;lumberjack&#39;</span><span class="p">,</span> <span class="p">(</span><span class="s">&#39;knights&#39;</span><span class="p">,</span> <span class="p">(</span><span class="s">&#39;ni&#39;</span><span class="p">,</span> <span class="p">(</span><span class="s">&#39;dead&#39;</span><span class="p">,</span>
<span class="gp">... </span><span class="p">(</span><span class="s">&#39;parrot&#39;</span><span class="p">,</span> <span class="p">(</span><span class="s">&#39;fresh fruit&#39;</span><span class="p">,))))))))</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">pp</span> <span class="o">=</span> <span class="n">pprint</span><span class="o">.</span><span class="n">PrettyPrinter</span><span class="p">(</span><span class="n">depth</span><span class="o">=</span><span class="mi">6</span><span class="p">)</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">pp</span><span class="o">.</span><span class="n">pprint</span><span class="p">(</span><span class="n">tup</span><span class="p">)</span>
<span class="go">(&#39;spam&#39;, (&#39;eggs&#39;, (&#39;lumberjack&#39;, (&#39;knights&#39;, (&#39;ni&#39;, (&#39;dead&#39;, (...)))))))</span>
</pre></div>
</div>
</div>
</dd></dl>

<p>The <a class="reference internal" href="#module-pprint" title="pprint: Data pretty printer."><code class="xref py py-mod docutils literal"><span class="pre">pprint</span></code></a> module also provides several shortcut functions:</p>
<dl class="function">
<dt id="pprint.pformat">
<code class="descclassname">pprint.</code><code class="descname">pformat</code><span class="sig-paren">(</span><em>object</em>, <em>indent=1</em>, <em>width=80</em>, <em>depth=None</em>, <em>*</em>, <em>compact=False</em><span class="sig-paren">)</span><a class="headerlink" href="#pprint.pformat" title="Permalink to this definition">¶</a></dt>
<dd><p>Return the formatted representation of <em>object</em> as a string.  <em>indent</em>,
<em>width</em>, <em>depth</em> and <em>compact</em> will be passed to the <a class="reference internal" href="#pprint.PrettyPrinter" title="pprint.PrettyPrinter"><code class="xref py py-class docutils literal"><span class="pre">PrettyPrinter</span></code></a>
constructor as formatting parameters.</p>
<div class="versionchanged">
<p><span class="versionmodified">Changed in version 3.4: </span>Added the <em>compact</em> parameter.</p>
</div>
</dd></dl>

<dl class="function">
<dt id="pprint.pprint">
<code class="descclassname">pprint.</code><code class="descname">pprint</code><span class="sig-paren">(</span><em>object</em>, <em>stream=None</em>, <em>indent=1</em>, <em>width=80</em>, <em>depth=None</em>, <em>*</em>, <em>compact=False</em><span class="sig-paren">)</span><a class="headerlink" href="#pprint.pprint" title="Permalink to this definition">¶</a></dt>
<dd><p>Prints the formatted representation of <em>object</em> on <em>stream</em>, followed by a
newline.  If <em>stream</em> is <code class="docutils literal"><span class="pre">None</span></code>, <code class="docutils literal"><span class="pre">sys.stdout</span></code> is used.  This may be used
in the interactive interpreter instead of the <a class="reference internal" href="functions.html#print" title="print"><code class="xref py py-func docutils literal"><span class="pre">print()</span></code></a> function for
inspecting values (you can even reassign <code class="docutils literal"><span class="pre">print</span> <span class="pre">=</span> <span class="pre">pprint.pprint</span></code> for use
within a scope).  <em>indent</em>, <em>width</em>, <em>depth</em> and <em>compact</em> will be passed
to the <a class="reference internal" href="#pprint.PrettyPrinter" title="pprint.PrettyPrinter"><code class="xref py py-class docutils literal"><span class="pre">PrettyPrinter</span></code></a> constructor as formatting parameters.</p>
<div class="versionchanged">
<p><span class="versionmodified">Changed in version 3.4: </span>Added the <em>compact</em> parameter.</p>
<div class="highlight-python3"><div class="highlight"><pre><span class="gp">&gt;&gt;&gt; </span><span class="kn">import</span> <span class="nn">pprint</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">stuff</span> <span class="o">=</span> <span class="p">[</span><span class="s">&#39;spam&#39;</span><span class="p">,</span> <span class="s">&#39;eggs&#39;</span><span class="p">,</span> <span class="s">&#39;lumberjack&#39;</span><span class="p">,</span> <span class="s">&#39;knights&#39;</span><span class="p">,</span> <span class="s">&#39;ni&#39;</span><span class="p">]</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">stuff</span><span class="o">.</span><span class="n">insert</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span> <span class="n">stuff</span><span class="p">)</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">pprint</span><span class="o">.</span><span class="n">pprint</span><span class="p">(</span><span class="n">stuff</span><span class="p">)</span>
<span class="go">[&lt;Recursion on list with id=...&gt;,</span>
<span class="go"> &#39;spam&#39;,</span>
<span class="go"> &#39;eggs&#39;,</span>
<span class="go"> &#39;lumberjack&#39;,</span>
<span class="go"> &#39;knights&#39;,</span>
<span class="go"> &#39;ni&#39;]</span>
</pre></div>
</div>
</div>
</dd></dl>

<dl class="function">
<dt id="pprint.isreadable">
<code class="descclassname">pprint.</code><code class="descname">isreadable</code><span class="sig-paren">(</span><em>object</em><span class="sig-paren">)</span><a class="headerlink" href="#pprint.isreadable" title="Permalink to this definition">¶</a></dt>
<dd><p id="index-0">Determine if the formatted representation of <em>object</em> is &#8220;readable,&#8221; or can be
used to reconstruct the value using <a class="reference internal" href="functions.html#eval" title="eval"><code class="xref py py-func docutils literal"><span class="pre">eval()</span></code></a>.  This always returns <code class="docutils literal"><span class="pre">False</span></code>
for recursive objects.</p>
<div class="highlight-python3"><div class="highlight"><pre><span class="gp">&gt;&gt;&gt; </span><span class="n">pprint</span><span class="o">.</span><span class="n">isreadable</span><span class="p">(</span><span class="n">stuff</span><span class="p">)</span>
<span class="go">False</span>
</pre></div>
</div>
</dd></dl>

<dl class="function">
<dt id="pprint.isrecursive">
<code class="descclassname">pprint.</code><code class="descname">isrecursive</code><span class="sig-paren">(</span><em>object</em><span class="sig-paren">)</span><a class="headerlink" href="#pprint.isrecursive" title="Permalink to this definition">¶</a></dt>
<dd><p>Determine if <em>object</em> requires a recursive representation.</p>
</dd></dl>

<p>One more support function is also defined:</p>
<dl class="function">
<dt id="pprint.saferepr">
<code class="descclassname">pprint.</code><code class="descname">saferepr</code><span class="sig-paren">(</span><em>object</em><span class="sig-paren">)</span><a class="headerlink" href="#pprint.saferepr" title="Permalink to this definition">¶</a></dt>
<dd><p>Return a string representation of <em>object</em>, protected against recursive data
structures.  If the representation of <em>object</em> exposes a recursive entry, the
recursive reference will be represented as <code class="docutils literal"><span class="pre">&lt;Recursion</span> <span class="pre">on</span> <span class="pre">typename</span> <span class="pre">with</span>
<span class="pre">id=number&gt;</span></code>.  The representation is not otherwise formatted.</p>
<div class="highlight-python3"><div class="highlight"><pre><span class="gp">&gt;&gt;&gt; </span><span class="n">pprint</span><span class="o">.</span><span class="n">saferepr</span><span class="p">(</span><span class="n">stuff</span><span class="p">)</span>
<span class="go">&quot;[&lt;Recursion on list with id=...&gt;, &#39;spam&#39;, &#39;eggs&#39;, &#39;lumberjack&#39;, &#39;knights&#39;, &#39;ni&#39;]&quot;</span>
</pre></div>
</div>
</dd></dl>

<div class="section" id="prettyprinter-objects">
<span id="id1"></span><h2>8.11.1. PrettyPrinter Objects<a class="headerlink" href="#prettyprinter-objects" title="Permalink to this headline">¶</a></h2>
<p><a class="reference internal" href="#pprint.PrettyPrinter" title="pprint.PrettyPrinter"><code class="xref py py-class docutils literal"><span class="pre">PrettyPrinter</span></code></a> instances have the following methods:</p>
<dl class="method">
<dt id="pprint.PrettyPrinter.pformat">
<code class="descclassname">PrettyPrinter.</code><code class="descname">pformat</code><span class="sig-paren">(</span><em>object</em><span class="sig-paren">)</span><a class="headerlink" href="#pprint.PrettyPrinter.pformat" title="Permalink to this definition">¶</a></dt>
<dd><p>Return the formatted representation of <em>object</em>.  This takes into account the
options passed to the <a class="reference internal" href="#pprint.PrettyPrinter" title="pprint.PrettyPrinter"><code class="xref py py-class docutils literal"><span class="pre">PrettyPrinter</span></code></a> constructor.</p>
</dd></dl>

<dl class="method">
<dt id="pprint.PrettyPrinter.pprint">
<code class="descclassname">PrettyPrinter.</code><code class="descname">pprint</code><span class="sig-paren">(</span><em>object</em><span class="sig-paren">)</span><a class="headerlink" href="#pprint.PrettyPrinter.pprint" title="Permalink to this definition">¶</a></dt>
<dd><p>Print the formatted representation of <em>object</em> on the configured stream,
followed by a newline.</p>
</dd></dl>

<p>The following methods provide the implementations for the corresponding
functions of the same names.  Using these methods on an instance is slightly
more efficient since new <a class="reference internal" href="#pprint.PrettyPrinter" title="pprint.PrettyPrinter"><code class="xref py py-class docutils literal"><span class="pre">PrettyPrinter</span></code></a> objects don&#8217;t need to be
created.</p>
<dl class="method">
<dt id="pprint.PrettyPrinter.isreadable">
<code class="descclassname">PrettyPrinter.</code><code class="descname">isreadable</code><span class="sig-paren">(</span><em>object</em><span class="sig-paren">)</span><a class="headerlink" href="#pprint.PrettyPrinter.isreadable" title="Permalink to this definition">¶</a></dt>
<dd><p id="index-1">Determine if the formatted representation of the object is &#8220;readable,&#8221; or can be
used to reconstruct the value using <a class="reference internal" href="functions.html#eval" title="eval"><code class="xref py py-func docutils literal"><span class="pre">eval()</span></code></a>.  Note that this returns
<code class="docutils literal"><span class="pre">False</span></code> for recursive objects.  If the <em>depth</em> parameter of the
<a class="reference internal" href="#pprint.PrettyPrinter" title="pprint.PrettyPrinter"><code class="xref py py-class docutils literal"><span class="pre">PrettyPrinter</span></code></a> is set and the object is deeper than allowed, this
returns <code class="docutils literal"><span class="pre">False</span></code>.</p>
</dd></dl>

<dl class="method">
<dt id="pprint.PrettyPrinter.isrecursive">
<code class="descclassname">PrettyPrinter.</code><code class="descname">isrecursive</code><span class="sig-paren">(</span><em>object</em><span class="sig-paren">)</span><a class="headerlink" href="#pprint.PrettyPrinter.isrecursive" title="Permalink to this definition">¶</a></dt>
<dd><p>Determine if the object requires a recursive representation.</p>
</dd></dl>

<p>This method is provided as a hook to allow subclasses to modify the way objects
are converted to strings.  The default implementation uses the internals of the
<a class="reference internal" href="#pprint.saferepr" title="pprint.saferepr"><code class="xref py py-func docutils literal"><span class="pre">saferepr()</span></code></a> implementation.</p>
<dl class="method">
<dt id="pprint.PrettyPrinter.format">
<code class="descclassname">PrettyPrinter.</code><code class="descname">format</code><span class="sig-paren">(</span><em>object</em>, <em>context</em>, <em>maxlevels</em>, <em>level</em><span class="sig-paren">)</span><a class="headerlink" href="#pprint.PrettyPrinter.format" title="Permalink to this definition">¶</a></dt>
<dd><p>Returns three values: the formatted version of <em>object</em> as a string, a flag
indicating whether the result is readable, and a flag indicating whether
recursion was detected.  The first argument is the object to be presented.  The
second is a dictionary which contains the <a class="reference internal" href="functions.html#id" title="id"><code class="xref py py-func docutils literal"><span class="pre">id()</span></code></a> of objects that are part of
the current presentation context (direct and indirect containers for <em>object</em>
that are affecting the presentation) as the keys; if an object needs to be
presented which is already represented in <em>context</em>, the third return value
should be <code class="docutils literal"><span class="pre">True</span></code>.  Recursive calls to the <a class="reference internal" href="functions.html#format" title="format"><code class="xref py py-meth docutils literal"><span class="pre">format()</span></code></a> method should add
additional entries for containers to this dictionary.  The third argument,
<em>maxlevels</em>, gives the requested limit to recursion; this will be <code class="docutils literal"><span class="pre">0</span></code> if there
is no requested limit.  This argument should be passed unmodified to recursive
calls. The fourth argument, <em>level</em>, gives the current level; recursive calls
should be passed a value less than that of the current call.</p>
</dd></dl>

</div>
<div class="section" id="example">
<span id="pprint-example"></span><h2>8.11.2. Example<a class="headerlink" href="#example" title="Permalink to this headline">¶</a></h2>
<p>To demonstrate several uses of the <a class="reference internal" href="#module-pprint" title="pprint: Data pretty printer."><code class="xref py py-func docutils literal"><span class="pre">pprint()</span></code></a> function and its parameters,
let&#8217;s fetch information about a project from <a class="reference external" href="https://pypi.python.org/pypi">PyPI</a>:</p>
<div class="highlight-python3"><div class="highlight"><pre><span class="gp">&gt;&gt;&gt; </span><span class="kn">import</span> <span class="nn">json</span>
<span class="gp">&gt;&gt;&gt; </span><span class="kn">import</span> <span class="nn">pprint</span>
<span class="gp">&gt;&gt;&gt; </span><span class="kn">from</span> <span class="nn">urllib.request</span> <span class="k">import</span> <span class="n">urlopen</span>
<span class="gp">&gt;&gt;&gt; </span><span class="k">with</span> <span class="n">urlopen</span><span class="p">(</span><span class="s">&#39;http://pypi.python.org/pypi/Twisted/json&#39;</span><span class="p">)</span> <span class="k">as</span> <span class="n">url</span><span class="p">:</span>
<span class="gp">... </span>    <span class="n">http_info</span> <span class="o">=</span> <span class="n">url</span><span class="o">.</span><span class="n">info</span><span class="p">()</span>
<span class="gp">... </span>    <span class="n">raw_data</span> <span class="o">=</span> <span class="n">url</span><span class="o">.</span><span class="n">read</span><span class="p">()</span><span class="o">.</span><span class="n">decode</span><span class="p">(</span><span class="n">http_info</span><span class="o">.</span><span class="n">get_content_charset</span><span class="p">())</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">project_info</span> <span class="o">=</span> <span class="n">json</span><span class="o">.</span><span class="n">loads</span><span class="p">(</span><span class="n">raw_data</span><span class="p">)</span>
</pre></div>
</div>
<p>In its basic form, <a class="reference internal" href="#module-pprint" title="pprint: Data pretty printer."><code class="xref py py-func docutils literal"><span class="pre">pprint()</span></code></a> shows the whole object:</p>
<div class="highlight-python3"><div class="highlight"><pre><span class="gp">&gt;&gt;&gt; </span><span class="n">pprint</span><span class="o">.</span><span class="n">pprint</span><span class="p">(</span><span class="n">project_info</span><span class="p">)</span>
<span class="go">{&#39;info&#39;: {&#39;_pypi_hidden&#39;: False,</span>
<span class="go">          &#39;_pypi_ordering&#39;: 125,</span>
<span class="go">          &#39;author&#39;: &#39;Glyph Lefkowitz&#39;,</span>
<span class="go">          &#39;author_email&#39;: &#39;glyph@twistedmatrix.com&#39;,</span>
<span class="go">          &#39;bugtrack_url&#39;: &#39;&#39;,</span>
<span class="go">          &#39;cheesecake_code_kwalitee_id&#39;: None,</span>
<span class="go">          &#39;cheesecake_documentation_id&#39;: None,</span>
<span class="go">          &#39;cheesecake_installability_id&#39;: None,</span>
<span class="go">          &#39;classifiers&#39;: [&#39;Programming Language :: Python :: 2.6&#39;,</span>
<span class="go">                          &#39;Programming Language :: Python :: 2.7&#39;,</span>
<span class="go">                          &#39;Programming Language :: Python :: 2 :: Only&#39;],</span>
<span class="go">          &#39;description&#39;: &#39;An extensible framework for Python programming, with &#39;</span>
<span class="go">                         &#39;special focus\r\n&#39;</span>
<span class="go">                         &#39;on event-based network programming and multiprotocol &#39;</span>
<span class="go">                         &#39;integration.&#39;,</span>
<span class="go">          &#39;docs_url&#39;: &#39;&#39;,</span>
<span class="go">          &#39;download_url&#39;: &#39;UNKNOWN&#39;,</span>
<span class="go">          &#39;home_page&#39;: &#39;http://twistedmatrix.com/&#39;,</span>
<span class="go">          &#39;keywords&#39;: &#39;&#39;,</span>
<span class="go">          &#39;license&#39;: &#39;MIT&#39;,</span>
<span class="go">          &#39;maintainer&#39;: &#39;&#39;,</span>
<span class="go">          &#39;maintainer_email&#39;: &#39;&#39;,</span>
<span class="go">          &#39;name&#39;: &#39;Twisted&#39;,</span>
<span class="go">          &#39;package_url&#39;: &#39;http://pypi.python.org/pypi/Twisted&#39;,</span>
<span class="go">          &#39;platform&#39;: &#39;UNKNOWN&#39;,</span>
<span class="go">          &#39;release_url&#39;: &#39;http://pypi.python.org/pypi/Twisted/12.3.0&#39;,</span>
<span class="go">          &#39;requires_python&#39;: None,</span>
<span class="go">          &#39;stable_version&#39;: None,</span>
<span class="go">          &#39;summary&#39;: &#39;An asynchronous networking framework written in Python&#39;,</span>
<span class="go">          &#39;version&#39;: &#39;12.3.0&#39;},</span>
<span class="go"> &#39;urls&#39;: [{&#39;comment_text&#39;: &#39;&#39;,</span>
<span class="go">           &#39;downloads&#39;: 71844,</span>
<span class="go">           &#39;filename&#39;: &#39;Twisted-12.3.0.tar.bz2&#39;,</span>
<span class="go">           &#39;has_sig&#39;: False,</span>
<span class="go">           &#39;md5_digest&#39;: &#39;6e289825f3bf5591cfd670874cc0862d&#39;,</span>
<span class="go">           &#39;packagetype&#39;: &#39;sdist&#39;,</span>
<span class="go">           &#39;python_version&#39;: &#39;source&#39;,</span>
<span class="go">           &#39;size&#39;: 2615733,</span>
<span class="go">           &#39;upload_time&#39;: &#39;2012-12-26T12:47:03&#39;,</span>
<span class="go">           &#39;url&#39;: &#39;https://pypi.python.org/packages/source/T/Twisted/Twisted-12.3.0.tar.bz2&#39;},</span>
<span class="go">          {&#39;comment_text&#39;: &#39;&#39;,</span>
<span class="go">           &#39;downloads&#39;: 5224,</span>
<span class="go">           &#39;filename&#39;: &#39;Twisted-12.3.0.win32-py2.7.msi&#39;,</span>
<span class="go">           &#39;has_sig&#39;: False,</span>
<span class="go">           &#39;md5_digest&#39;: &#39;6b778f5201b622a5519a2aca1a2fe512&#39;,</span>
<span class="go">           &#39;packagetype&#39;: &#39;bdist_msi&#39;,</span>
<span class="go">           &#39;python_version&#39;: &#39;2.7&#39;,</span>
<span class="go">           &#39;size&#39;: 2916352,</span>
<span class="go">           &#39;upload_time&#39;: &#39;2012-12-26T12:48:15&#39;,</span>
<span class="go">           &#39;url&#39;: &#39;https://pypi.python.org/packages/2.7/T/Twisted/Twisted-12.3.0.win32-py2.7.msi&#39;}]}</span>
</pre></div>
</div>
<p>The result can be limited to a certain <em>depth</em> (ellipsis is used for deeper
contents):</p>
<div class="highlight-python3"><div class="highlight"><pre><span class="gp">&gt;&gt;&gt; </span><span class="n">pprint</span><span class="o">.</span><span class="n">pprint</span><span class="p">(</span><span class="n">project_info</span><span class="p">,</span> <span class="n">depth</span><span class="o">=</span><span class="mi">2</span><span class="p">)</span>
<span class="go">{&#39;info&#39;: {&#39;_pypi_hidden&#39;: False,</span>
<span class="go">          &#39;_pypi_ordering&#39;: 125,</span>
<span class="go">          &#39;author&#39;: &#39;Glyph Lefkowitz&#39;,</span>
<span class="go">          &#39;author_email&#39;: &#39;glyph@twistedmatrix.com&#39;,</span>
<span class="go">          &#39;bugtrack_url&#39;: &#39;&#39;,</span>
<span class="go">          &#39;cheesecake_code_kwalitee_id&#39;: None,</span>
<span class="go">          &#39;cheesecake_documentation_id&#39;: None,</span>
<span class="go">          &#39;cheesecake_installability_id&#39;: None,</span>
<span class="go">          &#39;classifiers&#39;: [...],</span>
<span class="go">          &#39;description&#39;: &#39;An extensible framework for Python programming, with &#39;</span>
<span class="go">                         &#39;special focus\r\n&#39;</span>
<span class="go">                         &#39;on event-based network programming and multiprotocol &#39;</span>
<span class="go">                         &#39;integration.&#39;,</span>
<span class="go">          &#39;docs_url&#39;: &#39;&#39;,</span>
<span class="go">          &#39;download_url&#39;: &#39;UNKNOWN&#39;,</span>
<span class="go">          &#39;home_page&#39;: &#39;http://twistedmatrix.com/&#39;,</span>
<span class="go">          &#39;keywords&#39;: &#39;&#39;,</span>
<span class="go">          &#39;license&#39;: &#39;MIT&#39;,</span>
<span class="go">          &#39;maintainer&#39;: &#39;&#39;,</span>
<span class="go">          &#39;maintainer_email&#39;: &#39;&#39;,</span>
<span class="go">          &#39;name&#39;: &#39;Twisted&#39;,</span>
<span class="go">          &#39;package_url&#39;: &#39;http://pypi.python.org/pypi/Twisted&#39;,</span>
<span class="go">          &#39;platform&#39;: &#39;UNKNOWN&#39;,</span>
<span class="go">          &#39;release_url&#39;: &#39;http://pypi.python.org/pypi/Twisted/12.3.0&#39;,</span>
<span class="go">          &#39;requires_python&#39;: None,</span>
<span class="go">          &#39;stable_version&#39;: None,</span>
<span class="go">          &#39;summary&#39;: &#39;An asynchronous networking framework written in Python&#39;,</span>
<span class="go">          &#39;version&#39;: &#39;12.3.0&#39;},</span>
<span class="go"> &#39;urls&#39;: [{...}, {...}]}</span>
</pre></div>
</div>
<p>Additionally, maximum character <em>width</em> can be suggested. If a long object
cannot be split, the specified width will be exceeded:</p>
<div class="highlight-python3"><div class="highlight"><pre><span class="gp">&gt;&gt;&gt; </span><span class="n">pprint</span><span class="o">.</span><span class="n">pprint</span><span class="p">(</span><span class="n">project_info</span><span class="p">,</span> <span class="n">depth</span><span class="o">=</span><span class="mi">2</span><span class="p">,</span> <span class="n">width</span><span class="o">=</span><span class="mi">50</span><span class="p">)</span>
<span class="go">{&#39;info&#39;: {&#39;_pypi_hidden&#39;: False,</span>
<span class="go">          &#39;_pypi_ordering&#39;: 125,</span>
<span class="go">          &#39;author&#39;: &#39;Glyph Lefkowitz&#39;,</span>
<span class="go">          &#39;author_email&#39;: &#39;glyph@twistedmatrix.com&#39;,</span>
<span class="go">          &#39;bugtrack_url&#39;: &#39;&#39;,</span>
<span class="go">          &#39;cheesecake_code_kwalitee_id&#39;: None,</span>
<span class="go">          &#39;cheesecake_documentation_id&#39;: None,</span>
<span class="go">          &#39;cheesecake_installability_id&#39;: None,</span>
<span class="go">          &#39;classifiers&#39;: [...],</span>
<span class="go">          &#39;description&#39;: &#39;An extensible &#39;</span>
<span class="go">                         &#39;framework for Python &#39;</span>
<span class="go">                         &#39;programming, with &#39;</span>
<span class="go">                         &#39;special focus\r\n&#39;</span>
<span class="go">                         &#39;on event-based network &#39;</span>
<span class="go">                         &#39;programming and &#39;</span>
<span class="go">                         &#39;multiprotocol &#39;</span>
<span class="go">                         &#39;integration.&#39;,</span>
<span class="go">          &#39;docs_url&#39;: &#39;&#39;,</span>
<span class="go">          &#39;download_url&#39;: &#39;UNKNOWN&#39;,</span>
<span class="go">          &#39;home_page&#39;: &#39;http://twistedmatrix.com/&#39;,</span>
<span class="go">          &#39;keywords&#39;: &#39;&#39;,</span>
<span class="go">          &#39;license&#39;: &#39;MIT&#39;,</span>
<span class="go">          &#39;maintainer&#39;: &#39;&#39;,</span>
<span class="go">          &#39;maintainer_email&#39;: &#39;&#39;,</span>
<span class="go">          &#39;name&#39;: &#39;Twisted&#39;,</span>
<span class="go">          &#39;package_url&#39;: &#39;http://pypi.python.org/pypi/Twisted&#39;,</span>
<span class="go">          &#39;platform&#39;: &#39;UNKNOWN&#39;,</span>
<span class="go">          &#39;release_url&#39;: &#39;http://pypi.python.org/pypi/Twisted/12.3.0&#39;,</span>
<span class="go">          &#39;requires_python&#39;: None,</span>
<span class="go">          &#39;stable_version&#39;: None,</span>
<span class="go">          &#39;summary&#39;: &#39;An asynchronous networking &#39;</span>
<span class="go">                     &#39;framework written in &#39;</span>
<span class="go">                     &#39;Python&#39;,</span>
<span class="go">          &#39;version&#39;: &#39;12.3.0&#39;},</span>
<span class="go"> &#39;urls&#39;: [{...}, {...}]}</span>
</pre></div>
</div>
</div>
</div>


          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h3><a href="../contents.html">Table Of Contents</a></h3>
  <ul>
<li><a class="reference internal" href="#">8.11. <code class="docutils literal"><span class="pre">pprint</span></code> &#8212; Data pretty printer</a><ul>
<li><a class="reference internal" href="#prettyprinter-objects">8.11.1. PrettyPrinter Objects</a></li>
<li><a class="reference internal" href="#example">8.11.2. Example</a></li>
</ul>
</li>
</ul>

  <h4>Previous topic</h4>
  <p class="topless"><a href="copy.html"
                        title="previous chapter">8.10. <code class="docutils literal"><span class="pre">copy</span></code> &#8212; Shallow and deep copy operations</a></p>
  <h4>Next topic</h4>
  <p class="topless"><a href="reprlib.html"
                        title="next chapter">8.12. <code class="docutils literal"><span class="pre">reprlib</span></code> &#8212; Alternate <code class="docutils literal"><span class="pre">repr()</span></code> implementation</a></p>
<h3>This Page</h3>
<ul class="this-page-menu">
  <li><a href="../bugs.html">Report a Bug</a></li>
  <li><a href="../_sources/library/pprint.txt"
         rel="nofollow">Show Source</a></li>
</ul>

<div id="searchbox" style="display: none" role="search">
  <h3>Quick search</h3>
    <form class="search" action="../search.html" method="get">
      <input type="text" name="q" />
      <input type="submit" value="Go" />
      <input type="hidden" name="check_keywords" value="yes" />
      <input type="hidden" name="area" value="default" />
    </form>
    <p class="searchtip" style="font-size: 90%">
    Enter search terms or a module, class or function name.
    </p>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>  
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="right" >
          <a href="reprlib.html" title="8.12. reprlib — Alternate repr() implementation"
             >next</a> |</li>
        <li class="right" >
          <a href="copy.html" title="8.10. copy — Shallow and deep copy operations"
             >previous</a> |</li>
        <li><img src="../_static/py.png" alt=""
                 style="vertical-align: middle; margin-top: -1px"/></li>
        <li><a href="https://www.python.org/">Python</a> &raquo;</li>
        <li>
          <span class="version_switcher_placeholder">3.5.1</span>
          <a href="../index.html">Documentation</a> &raquo;
        </li>

          <li class="nav-item nav-item-1"><a href="index.html" >The Python Standard Library</a> &raquo;</li>
          <li class="nav-item nav-item-2"><a href="datatypes.html" >8. Data Types</a> &raquo;</li> 
      </ul>
    </div>  
    <div class="footer">
    &copy; <a href="../copyright.html">Copyright</a> 1990-2016, Python Software Foundation.
    <br />
    The Python Software Foundation is a non-profit corporation.
    <a href="https://www.python.org/psf/donations/">Please donate.</a>
    <br />
    Last updated on Jan 08, 2016.
    <a href="../bugs.html">Found a bug</a>?
    <br />
    Created using <a href="http://sphinx.pocoo.org/">Sphinx</a> 1.3.3.
    </div>

  </body>
</html>